{-|
Module      : Gargantext.Database.Admin.Types.Hyperdata
Description :
Copyright   : (c) CNRS, 2017-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}


{-# OPTIONS_GHC -fno-warn-unused-imports #-}

module Gargantext.Database.Admin.Types.Hyperdata
  ( module Gargantext.Database.Admin.Types.Hyperdata.Any
  , module Gargantext.Database.Admin.Types.Hyperdata.Contact
  , module Gargantext.Database.Admin.Types.Hyperdata.Corpus
  , module Gargantext.Database.Admin.Types.Hyperdata.Dashboard
  , module Gargantext.Database.Admin.Types.Hyperdata.Document
  , module Gargantext.Database.Admin.Types.Hyperdata.File
  , module Gargantext.Database.Admin.Types.Hyperdata.Folder
  , module Gargantext.Database.Admin.Types.Hyperdata.Frame
  , module Gargantext.Database.Admin.Types.Hyperdata.List
  , module Gargantext.Database.Admin.Types.Hyperdata.Model
  , module Gargantext.Database.Admin.Types.Hyperdata.Prelude
  , module Gargantext.Database.Admin.Types.Hyperdata.Texts
  , module Gargantext.Database.Admin.Types.Hyperdata.Phylo
  , module Gargantext.Database.Admin.Types.Hyperdata.User
  , module Gargantext.Core.Viz.Graph.Types
  )
  where

import Gargantext.Database.Admin.Types.Hyperdata.Any
import Gargantext.Database.Admin.Types.Hyperdata.Contact
import Gargantext.Database.Admin.Types.Hyperdata.Corpus
import Gargantext.Database.Admin.Types.Hyperdata.Dashboard
import Gargantext.Database.Admin.Types.Hyperdata.Document
import Gargantext.Database.Admin.Types.Hyperdata.File
import Gargantext.Database.Admin.Types.Hyperdata.Folder
import Gargantext.Database.Admin.Types.Hyperdata.Frame
import Gargantext.Database.Admin.Types.Hyperdata.List
import Gargantext.Database.Admin.Types.Hyperdata.Model
import Gargantext.Database.Admin.Types.Hyperdata.Prelude (Hyperdata, HyperdataC)
import Gargantext.Database.Admin.Types.Hyperdata.Texts
import Gargantext.Database.Admin.Types.Hyperdata.Phylo
import Gargantext.Database.Admin.Types.Hyperdata.User
import Gargantext.Core.Viz.Graph.Types (HyperdataGraph(..), defaultHyperdataGraph)
